// Facebook enthaelt eine Menge von Nutzern
class Facebook {
	static Nutzer[] nutzer;

	// liefert den Nutzer mit dem angegebenen Namen; liefert null, wenn
	// ein Nutzer mit dem Namen nicht in Facebook existiert
	static Nutzer getNutzer(String name) {
		return nutzer[0]; // dummy-Implementierung
	}
}

// jeder Nutzer hat einen eindeutigen Namen; jeder Nutzer hat eine Menge an
// Freunden; jedem Nutzer gehoert eine Pinnwand, auf der er oder andere Nutzer
// Nachrichten hinterlassen koennen
class Nutzer {
	String name;
	Nutzer[] freunde;
	Pinnwand pinnwand;

	boolean equals(Nutzer n) {
		return this.name.equals(n.name);
	}

	// liefert den Namen des Nutzers
	String getName() {
		return this.name;
	}

	// liefert alle Freunde des Nutzers
	Nutzer[] getFreunde() {
		return this.freunde;
	}

	// liefert die Pinnwand des Nutzers
	Pinnwand getPinnwand() {
		return this.pinnwand;
	}
}

// jede Pinnwand gehoert einem Facebook-Nutzer; auf einer Pinnwand koennen
// Nachrichten hinterlassen werden
class Pinnwand {
	Nutzer eigentuemer;
	Nachricht[] nachrichten;

	// liefert den Eigentuemer der Pinnwand
	Nutzer getEigentuemer() {
		return this.eigentuemer;
	}

	// liefert die Nachrichten, die an der Pinnwand hinterlassen worden sind
	Nachricht[] getNachrichten() {
		return this.nachrichten;
	}
}

// eine Nachricht besteht aus einem Text; jede Nachricht steht an genau einer
// Pinnwand; Nutzer koennen durch Druecken eines "Gefaellt mir"-Buttons
// signalisieren, dass ihnen die Nachricht gefaellt
class Nachricht {
	String text;
	Pinnwand pinnwand;
	Nutzer[] gefaelltDasNutzer;

	// liefert den Text der Nachricht
	String getText() {
		return this.text;
	}

	// liefert die Pinnwand, an der sich die Nachricht befindet
	Pinnwand getPinnwand() {
		return this.pinnwand;
	}

	// liefert die Nutzer, die denen die Nachricht gefaellt
	Nutzer[] getGefaelltDasNutzer() {
		return this.gefaelltDasNutzer;
	}
}

public class UE11Aufgabe27 {

	public static void main(String[] args) {
		String name = IO.readString("Name: ");
		int anzahl = 0;
		Nutzer nutzer = Facebook.getNutzer(name);
		if (nutzer != null) {
			Nutzer[] freunde = nutzer.getFreunde();
			for (Nutzer freund : freunde) {
				Nachricht[] nachrichten = freund.getPinnwand().getNachrichten();
				for (Nachricht nachricht : nachrichten) {
					Nutzer[] gefaelltDas = nachricht.getGefaelltDasNutzer();
					for (Nutzer gefaelltDasNutzer : gefaelltDas) {
						if (gefaelltDasNutzer.equals(nutzer)) {
							anzahl++;
						}
					}
				}
			}
			System.out.println("Der Nutzer mit dem Namen " + name + " hat " + anzahl
					+ "\"Gefaellt mir\"-Angaben auf den Pinnwaenden seiner Freunde!");
		} else {
			System.out.println("Ein Nutzer mit dem Namen " + name + " ist unbekannt!");
		}
	}
}
