class NimmSpielzug {
	int anzahl;

	NimmSpielzug(int anzahl) {
		this.anzahl = anzahl;
	}

	int getAnzahl() {
		return anzahl;
	}
}

class NimmSpielbrett {

	int anzahlKugeln;

	NimmSpielbrett(int kugeln) {
		anzahlKugeln = kugeln;
	}

	int getAnzahlKugeln() {
		return anzahlKugeln;
	}

	void ausfuehren(NimmSpielzug zug) {
		anzahlKugeln = anzahlKugeln - zug.getAnzahl();
	}

	void print() {
		IO.println("Aktuelle Anzahl an Kugeln = " + anzahlKugeln);
	}

}

class NimmSpieler {

	int nummer;

	NimmSpieler(int nr) {
		nummer = nr;
	}

	int getNummer() {
		return nummer;
	}

	NimmSpielzug liefereSpielzug() {
		return new NimmSpielzug(IO.readInt("Spieler " + nummer + "! 1 oder 2 wegnehmen? "));
	}
}

class NimmSchiedsrichter {

	NimmSpielbrett brett;
	NimmSpieler[] spieler;
	int aktuellerSpielerNr;

	NimmSchiedsrichter(NimmSpielbrett brett, NimmSpieler[] spieler) {
		this.brett = brett;
		this.spieler = spieler;
		this.aktuellerSpielerNr = -1;
	}

	boolean isSpielzugGueltig(NimmSpielzug zug) {
		return zug.getAnzahl() == 1 || zug.getAnzahl() == 2;
	}

	boolean isSpielende() {
		return brett.getAnzahlKugeln() <= 0;
	}

	NimmSpieler getNaechsterSpieler() {
		if (aktuellerSpielerNr == -1) {
			aktuellerSpielerNr = 0;
		} else {
			aktuellerSpielerNr = (aktuellerSpielerNr + 1) % spieler.length;
		}
		return spieler[aktuellerSpielerNr];
	}

	void verkuendeSieger() {
		IO.println("Spieler " + spieler[aktuellerSpielerNr].getNummer() + " hat gewonnen!");
	}

	void verkuendeFehlerhaftenSpielzug() {
		IO.println("Fehlerhafter Spielzug! Bitte wiederholen!");
	}

}

class NimmSpiel {
	NimmSpielbrett brett;
	NimmSpieler[] spieler;
	NimmSchiedsrichter schiedsrichter;

	NimmSpiel(int anzahlKugeln, int anzahlSpieler) {
		brett = new NimmSpielbrett(anzahlKugeln);
		spieler = new NimmSpieler[anzahlSpieler];
		for (int i = 0; i < anzahlSpieler; i++) {
			spieler[i] = new NimmSpieler(i + 1);
		}
		schiedsrichter = new NimmSchiedsrichter(brett, spieler);
	}

	void spielen() {
		NimmSpieler aktuellerSpieler = schiedsrichter.getNaechsterSpieler();
		while (true) {
			brett.print();
			NimmSpielzug zug = aktuellerSpieler.liefereSpielzug();
			while (!schiedsrichter.isSpielzugGueltig(zug)) {
				schiedsrichter.verkuendeFehlerhaftenSpielzug();
				zug = aktuellerSpieler.liefereSpielzug();
			}
			brett.ausfuehren(zug);
			if (schiedsrichter.isSpielende()) {
				break;
			}
			aktuellerSpieler = schiedsrichter.getNaechsterSpieler();
		}
		schiedsrichter.verkuendeSieger();
	}
}

public class UE11Aufgabe32 {

	public static void main(String[] args) {
		int anzahlKugeln = 19; // Startwert > 0
		int anzahlSpieler = 3; // Konstante >= 2
		NimmSpiel spiel = new NimmSpiel(anzahlKugeln, anzahlSpieler);
		spiel.spielen();
	}

	static void imperativeLoesung() {
		int anzahlKugeln = 19; // Startwert > 0
		int anzahlSpieler = 2; // Konstante >= 2
		int aktuellerSpieler = 1; // Startwert zwischen 1 und anzahlSpieler
		while (true) {
			IO.println("Aktuelle Anzahl an Kugeln = " + anzahlKugeln);
			int anzahlWegzunehmenderKugeln = IO
					.readInt("Spieler " + aktuellerSpieler + "! 1 oder 2 Kugeln wegnehmen? ");
			while (anzahlWegzunehmenderKugeln < 1 || anzahlWegzunehmenderKugeln > 2) {
				IO.println("Fehlerhafter Spielzug! Bitte wiederholen!");
				anzahlWegzunehmenderKugeln = IO
						.readInt("Spieler " + aktuellerSpieler + "! 1 oder 2 Kugeln wegnehmen? ");
			}
			anzahlKugeln = anzahlKugeln - anzahlWegzunehmenderKugeln;
			if (anzahlKugeln <= 0) {
				break;
			}
			aktuellerSpieler = aktuellerSpieler % anzahlSpieler + 1;
		}
		IO.println("Spieler " + aktuellerSpieler + " hat gewonnen!");
	}

}
