class FachNote {
	String fach; // das Fach (Deutsch, Mathe, ...)
	int note; // die Note in dem Fach (1 .. 6)

	FachNote(String fach, int note) {
		this.fach = fach;
		this.note = note;
	}

	String getFach() {
		return this.fach;
	}

	int getNote() {
		return this.note;
	}
}

class Schueler {
	String name; // Name des Schuelers
	FachNote[] noten; // Noten in den einzelnen Faechern

	Schueler(String name, FachNote[] noten) {
		this.name = name;
		this.noten = noten;
	}

	String getName() {
		return this.name;
	}

	FachNote[] getNoten() {
		return this.noten;
	}
}

public class UE11Aufgabe7 {

	/**
	 * Berechnet die Durchschnittsnote der uebergebenen Schueler in dem
	 * uebergebenen Fach. Hinweise: nicht alle Schueler muessen dieselben
	 * Faecher belegen. Sie koennen davon ausgehen, dass alle Faecher auch durch
	 * mindestens einen Schueler belegt werden.
	 * 
	 * @param schueler
	 *            Menge an Schuelern (!= null);
	 * @param fach
	 *            Name des Faches (!= null)
	 * @return die Durchschnittsnote der uebergebenen Schueler in dem
	 *         uebergebenen Fach
	 */
	static double durchschnittsnote(Schueler[] schueler, String fach) {
		int summe = 0;
		int anzahl = 0;
		for (Schueler s : schueler) {
			FachNote[] noten = s.getNoten();
			for (FachNote n : noten) {
				if (n.getFach().equals(fach)) {
					summe += n.getNote();
					anzahl++;
				}
			}
		}

		return (double) summe / anzahl;
	}

	// Testprogramm
	public static void main(String[] args) {
		Schueler[] schueler = new Schueler[3];

		FachNote[] noten = new FachNote[3];
		noten[0] = new FachNote("Mathe", 1);
		noten[1] = new FachNote("Deutsch", 1);
		noten[2] = new FachNote("Englisch", 2);
		schueler[0] = new Schueler("dibo", noten);

		noten = new FachNote[3];
		noten[0] = new FachNote("Mathe", 2);
		noten[1] = new FachNote("Deutsch", 2);
		noten[2] = new FachNote("Englisch", 4);
		schueler[1] = new Schueler("karl", noten);

		noten = new FachNote[3];
		noten[0] = new FachNote("Mathe", 3);
		noten[1] = new FachNote("Deutsch", 5);
		noten[2] = new FachNote("Englisch", 5);
		schueler[2] = new Schueler("ute", noten);

		System.out.println(durchschnittsnote(schueler, "Mathe"));
	}

}
