
class World {
	boolean[][] cells;
	int size;
	Ant ant;

	World(int worldSize) {
		this.cells = new boolean[worldSize][worldSize];
		this.size = worldSize;
		this.ant = new Ant(this, this.size / 2, this.size / 2);
	}

	int getSize() {
		return this.size;
	}

	Ant getAnt() {
		return this.ant;
	}

	boolean isCellBlack(int row, int col) {
		return this.cells[row][col];
	}

	void changeCellState(int row, int col) {
		this.cells[row][col] = !this.cells[row][col];
	}
}

class Ant {

	World world;
	int antRow;
	int antColumn;
	int direction; // 0 = Nord, 1 = West, 2 = Sued, 3 = Ost

	Ant(World world, int row, int col) {
		this.world = world;
		this.antRow = row;
		this.antColumn = col;
		this.direction = 0; // Norden
	}

	void nextStep() {
		if (!this.world.isCellBlack(this.antRow, this.antColumn)) {
			this.world.changeCellState(this.antRow, this.antColumn);
			this.direction = (this.direction + 4 - 1) % 4; // nach rechts
			this.forward();
		} else {
			this.world.changeCellState(this.antRow, this.antColumn);
			this.direction = (this.direction + 1) % 4; // nach links
			this.forward();
		}
	}

	void forward() {
		switch (this.direction) {
		case 0:
			this.antRow = (this.antRow + this.world.getSize() - 1)
					% this.world.getSize();
			break;
		case 1:
			this.antColumn = (this.antColumn + this.world.getSize() - 1)
					% this.world.getSize();
			break;
		case 2:
			this.antRow = (this.antRow + 1) % this.world.getSize();
			break;
		case 3:
			this.antColumn = (this.antColumn + 1) % this.world.getSize();
			break;
		}
	}
}
